<!DOCTYPE html>
<html lang="en" th:lang="#{lang}" xmlns:th="http://www.thymeleaf.org">
<head>
    <!--CSS -->
    <link th:href="@{/webjars/dropzone/5.5.0/min/dropzone.min.css}" rel="stylesheet">

    <!--/*/ <th:block th:include="fragments/layout :: head">
        </th:block> /*/-->

    <!--SCRIPTS-->
    <script th:src="@{/webjars/dropzone/5.5.0/min/dropzone.min.js}"></script>
    <script th:src="@{/js/ckeditor5/ckeditor.js}"></script>
    <script th:src="@{/js/ckeditor5/translations/cs.js}"></script>
</head>
<body>

<div id="wrapper">

    <div th:replace="fragments/layout :: header('admin')"></div>


    <!--CAROUSEL-->
    <div th:replace="fragments/layout :: carousel-sm"></div>

    <main id="main" class="container mt-2">

        <div class="d-lg-flex">
            <div class="p-2">
                <!--BACK-->
                <div class="mb-2">
                    <a class="btn btn-sm btn-outline-secondary w-100" th:href="@{/admin/products}">
                        <i class="fas fa-chevron-left mr-2"></i>
                        Zpět na seznam
                    </a>
                </div>
                <!--SIDE NAV-->
                <div th:replace="fragments/layout :: adminSideNav('products')"></div>
            </div>

            <div class="flex-grow-1 p-2">
                <!--HEADING-->
                <h2 class="mb-3 pb-2 border-bottom">Nový produkt</h2>

                <div id="errorMessage" class="alert alert-danger alert-dismissible fade show" hidden="hidden"
                     role="alert">
                    <span id="errorText"></span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>

                <form id="product-form" class="dropzone needs-validation" method="post" enctype="multipart/form-data"
                      th:action="@{/admin/product/add}" th:object="${product}" th:fragment="productEdit(product)"
                      novalidate>

                    <input hidden th:field="*{id}">

                    <div class="row no-gutters">
                        <div class="col-md-6 pr-md-1">
                            <!--GENERAL INFO-->
                            <div class="card mb-2">
                                <div class="card-header">
                                    Základní údaje
                                </div>
                                <div class="card-body">
                                    <!--NAME-->
                                    <div class="form-group row no-gutters">
                                        <label for="name"
                                               class="col-4 col-sm-3 col-md-4 col-lg-3 col-form-label">Název:</label>
                                        <div class="col-8 col-sm-9 col-md-8 col-lg-9">
                                            <input type="text" class="form-control" id="name" th:field="*{name}"
                                                   th:classappend="${#fields.hasErrors('name')} ? 'is-invalid'"
                                                   required>
                                            <span id="nameError" class="text-danger"
                                                  hidden="hidden">název je povinný</span>
                                        </div>
                                    </div>

                                    <!--PRICE-->
                                    <div class="form-group row no-gutters">
                                        <label for="price"
                                               class="col-4 col-sm-3 col-md-4 col-lg-3 col-form-label">Cena:</label>
                                        <div class="input-group col-8 col-sm-9 col-md-8 col-lg-9">
                                            <input type="text" class="form-control" id="price" th:field="*{price}">
                                            <div class="input-group-append">
                                                <span class="input-group-text">Kč</span>
                                            </div>
                                        </div>
                                    </div>

                                    <!--BAIL-->
                                    <div class="form-group row no-gutters">
                                        <label for="bail"
                                               class="col-4 col-sm-3 col-md-4 col-lg-3 col-form-label">Kauce:</label>
                                        <div class="input-group col-8 col-sm-9 col-md-8 col-lg-9">
                                            <input type="text" class="form-control" id="bail" th:field="*{bail}">
                                            <div class="input-group-append">
                                                <span class="input-group-text">Kč</span>
                                            </div>
                                        </div>
                                    </div>

                                    <!--CATEGORY-->
                                    <div class="form-group row no-gutters">
                                        <label for="name"
                                               class="col-4 col-sm-3 col-md-4 col-lg-3 col-form-label">Kategorie:</label>
                                        <div class="col-8 col-sm-9 col-md-8 col-lg-9">
                                            <select class="form-control" th:field="*{category}">
                                                <option th:each="cat : ${T(cz.david.minirental.model.enums.ProductCategory).values()}"
                                                        th:value="${cat}"
                                                        th:text="${cat.getHeading()}">
                                                </option>
                                            </select>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </div>
                        <div class="col-md-6 pl-md-1">

                            <!--ACCESSORIES-->
                            <div class="card mb-2" id="accessories" th:fragment="accesories">
                                <div class="card-header">
                                    Příslušenství
                                </div>
                                <div class="card-body clearfix">

                                    <!--ACCESSORY-->
                                    <div class="form-group row no-gutters" th:each="accessory, iStat : ${product.accessories}">
                                        <p class="col-2 col-form-label"
                                           th:text="${iStat.index + 1} + '.'">1.</p>
                                        <div class="input-group col-10">
                                            <input type="hidden"
                                                   th:field="${product.accessories[__${iStat.index}__].id}">
                                            <input type="text" class="form-control"
                                                   th:field="${product.accessories[__${iStat.index}__].name}">
                                            <div class="input-group-append">
                                                <div class="input-group-text">
                                                    <input type="checkbox"
                                                           th:field="${product.accessories[__${iStat.index}__].offer}">
                                                </div>
                                            </div>
                                            <div class="input-group-append">
                                                <button class="btn btn-secondary" type="button" name="removeAccessory"
                                                        th:value="${iStat.index}">
                                                    <i class="fas fa-trash"></i>
                                                </button>
                                            </div>
                                        </div>
                                        <span class="text-danger invalid-feedback">kauce je povinná</span>
                                    </div>

                                    <button type="button" class="btn btn-sm btn-success float-right"
                                            name="addAccessory">Přidat
                                        příslušenství
                                    </button>

                                </div>

                                <script>
                                    function replaceItems(html) {
                                        $('#accessories').replaceWith($(html));
                                    }

                                    $('button[name="addAccessory"]').click(function (event) {
                                        event.preventDefault();
                                        var data = $("#accessories").find("input").serialize();
                                        $.post('/admin/accessory/add', data, replaceItems);
                                    });

                                    $('button[name="removeAccessory"]').click(function (event) {
                                        event.preventDefault();
                                        var data = $("#accessories").find("input").serialize();
                                        data += '&index=' + $(this).val();
                                        $.post('/admin/accessory/remove', data, replaceItems);
                                    });
                                </script>
                            </div>

                        </div>
                    </div>

                    <!--DESCRIPTION-->
                    <div class="card mb-2">
                        <div class="card-header">
                            <label for="description" class="mb-0">Stručný popis</label>
                        </div>
                        <div class="card-body p-0">
                    <textarea id="description" rows="3" th:field="*{description}"
                              class="form-control border-0"></textarea>
                        </div>
                    </div>

                    <!--HTML-->
                    <div class="card mb-2">
                        <div class="card-header">
                            <label for="html" class="mb-0">Popis</label>
                        </div>
                        <div class="card-body p-0">

                            <textarea id="html" class="ckeditor" th:field="*{html}"></textarea>

                            <script>
                                initCKEditor('#html');
                            </script>

                        </div>
                    </div>

                    <!--IMAGES-->
                    <div class="card">
                        <div class="card-header">
                            Obrázky
                        </div>
                        <div id="images-div" class="card-body">

                            <!--HIDDEN-->
                            <div class="d-none" th:each="image, iStat : ${product.images}">
                                <input type="hidden" th:field="${product.images[__${iStat.index}__].id}">
                            </div>

                            <input id="hdnImgIndex" hidden name="imgIndex" value="-1">
                            <input id="hdnSavedImages" hidden name="savedImages" value="">

                            <div class="dz-message">
                                <i id="img-upload" class="fas fa-cloud-upload-alt fa-4x text-gray"></i>
                                <p class="mb-1">Přetáhni obrázky sem</p>
                                <p class="small text-muted">nebo klikni</p>
                            </div>

                            <div class="fallback"> <!-- this is the fallback if JS isn't working -->
                                <input name="files" type="file" multiple/>
                            </div>
                            <div id="previews" class="dropzone-previews">
                            </div> <!-- this is were the previews should be shown. -->

                        </div>
                    </div>

                    <div class="d-flex flex-wrap pt-2">
                        <input id="hiddenType" name="btn" value="redirect" hidden="hidden">
                        <button type="button" id="submitBtnNext" class="w-100 w-sm-auto btn btn-outline-success m-1 ml-sm-auto">
                            Uložit a přidat další
                        </button>
                        <button type="button" id="submitBtnSave" class="w-100 w-sm-auto btn btn-orange m-1 px-5">
                            Uložit
                        </button>
                    </div>
                </form>

            </div>
        </div>
    </main>
</div>

<!-- SPINNER -->
<div th:replace="fragments/layout :: spinner"></div>

<div th:replace="fragments/layout :: footer"></div>

<script>
    var myDropzone;

    Dropzone.options.productForm = { //imagesDiv, productForm
        paramName: 'files',
        url: '/admin/product/add',
        autoProcessQueue: false,
        uploadMultiple: true,
        parallelUploads: 100,
        maxFiles: 100,
        acceptedFiles: 'image/*',
        addRemoveLinks: true,
        previewsContainer: "#previews",
        //Translate
        dictRemoveFile: 'Smazat',

        // The setting up of the dropzone
        init: function () {
            myDropzone = this;

            // First change the button to actually tell Dropzone to process the queue.
            document.getElementById('submitBtnSave').addEventListener("click", function (e) {
                document.getElementById('hiddenType').value = 'save';
                formSubmit(myDropzone, '/admin/product/add');
            });

            // First change the button to actually tell Dropzone to process the queue.
            document.getElementById('submitBtnNext').addEventListener("click", function (e) {
                // Make sure that the form isn't actually being sent.
                /*e.preventDefault();
                e.stopPropagation();*/

                document.getElementById('hiddenType').value = 'next';
                formSubmit(myDropzone, '/admin/product/add');
            });

            myDropzone.on("addedfile", function (file) {

                //první obrázek se zvolí jako aktivní - hlavní obrázek
                var items = $('.dz-preview');
                if (items.length === 1) {
                    items.eq(0).addClass("active");
                }
            });

            // Listen to the sendingmultiple event. In this case, it's the sendingmultiple event instead
            // of the sending event because uploadMultiple is set to true.
            this.on("sendingmultiple", function () {
                // Gets triggered when the form is actually being sent.
                // Hide the success button or the complete form.
            });
            this.on("successmultiple", function (files, response) {
                // Gets triggered when the files have successfully been sent.
                // Redirect user or notify of success.

                responseFunc(response);
            });
            this.on("errormultiple", function (files, response) {
                // Gets triggered when there was an error sending the files.
                // Maybe show form again, and notify user of error

                responseFunc(response);
            });
        }
    };
</script>

</body>
</html>